# /www/psets/1-quotations/create-table.tcl
#
# Copyright (C) 1998-2007 various parties
#
# This program is free software. You can redistribute it and/or modify it under 
# the terms of the GNU General Public License as published by the Free Software 
# Foundation; either version 2 of the License, or (at your option) any later version. 
# This program is distributed in the hope that it will be useful, but WITHOUT ANY 
# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
# PARTICULAR PURPOSE. See the GNU General Public License for more details.
#
# Edited by frank.bergmann@project-open.com

# Define the SQL to create the new table
set create_sql "
	create table quotations (
		quotation_id		integer primary key,
		quotation_user_id	integer references users,
		quotation_text		text
	);
"

# Execute the SQL and catch possible errors (table already there...)
catch {
    db_dml create_table $create_sql
} err_msg


# Format the HTML to return to the user.
# The template 1-create-table.adp puts a header and footer around this.
set return_html "
	<h1>1-Quotations / 1-create-table</h1>
	<h2>Here is the SQL we want to execute:</h2>
	<pre>$create_sql</pre>
	<h2>Here is the error message:</h2>
	<pre>$err_msg</pre>
"
