# /www/psets/1-quotations/list-quotes.tcl
#
# Copyright (C) 1998-2007 various parties
#
# This program is free software. You can redistribute it and/or modify it under 
# the terms of the GNU General Public License as published by the Free Software 
# Foundation; either version 2 of the License, or (at your option) any later version. 
# This program is distributed in the hope that it will be useful, but WITHOUT ANY 
# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
# PARTICULAR PURPOSE. See the GNU General Public License for more details.
#
# Edited by frank.bergmann@project-open.com


# Pull out everything we want to know about a quotation from the DB.
# We try to do as much as possible in SQL, this will save TCL code later.
set list_sql "
	select
		q.quotation_id,
		q.quotation_text,
		q.quotation_user_id,
		p.first_names,
		p.last_name
	from
		quotations q,
		persons p
	where
		p.person_id = q.quotation_user_id
	order by
		quotation_id
"

# "Manual" HTML formatting. This is the most straight forward way to
# format html, but definitely not the best one. This should be reserved
# for the few occasions where you really need a custom HTML output.

set quotes_list_html ""
db_foreach quotation_list $list_sql {
    set user_url "/intranet/users/view?user_id=$quotation_user_id"
    append quotes_list_html "
	<tr>
	  <td>$quotation_id</td>
	  <td><a href='$user_url'>$first_names $last_name</a></td>
	  <td>$quotation_text</td>
	</tr>
    "
}

set quotes_list_html "
	<table>
	<tr class=rowtitle>
	  <td class=rowtitle>ID</td>
	  <td class=rowtitle>Who?</td>
	  <td class=rowtitle>Quote</td>
	</tr>
	$quotes_list_html
	</table>
"
