# /psets/2-notes/list-notes
#
# Copyright (C) 1998-2007 various parties
#
# This program is free software. You can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later version.
# This program is distributed in the hope that it will be useful, but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
# PARTICULAR PURPOSE. See the GNU General Public License for more details.
#
# Edited by <frank.bergmann@project-open-com>

# ---------------------------------------------------------------
# Page Contract
# ---------------------------------------------------------------

ad_page_contract { 
    Shows a list of all notes.
    @author frank.bergmann@project-open.com

    @param object_id Allows to display notes related to a specific
           object. Not used here in the pset.
} {
    { object_id 0}
}

# ---------------------------------------------------------------
# Defaults & Security
# ---------------------------------------------------------------

# User id already verified by filters
set user_id [ad_maybe_redirect_for_registration]
set page_title "Notes"
set context_bar [im_context_bar $page_title]

# This is the start of a "return_url" pattern. After deleting a note
# or creating a new note, we would like the browser to return to this
# page.
set return_url [im_url_with_query]

# ---------------------------------------------------------------
# Expenses info
# ---------------------------------------------------------------

template::list::create \
    -name notes-list \
    -multirow note_lines \
    -key note_id \
    -has_checkboxes \
    -bulk_actions { "Delete" "notes-del" "Delete checked items" } \
    -bulk_action_export_vars { return_url } \
    -row_pretty_plural "Note Items" \
    -elements {
	note_chk {
	    label "<input type=\"checkbox\" 
                          name=\"_dummy\" 
                          onclick=\"acs_ListCheckAll('notes_list', this.checked)\" 
                          title=\"Check/uncheck all rows\">"
	    display_template {
		@note_lines.note_chk;noquote@
	    }
	}
	creation_date {
	    label "Date"
	    link_url_eval {[export_vars -base new {note_id {form_mode display} return_url}]}
	}
        creation_user {
	    label "By User"
	    link_url_eval "/intranet/users/view?user_id=$creation_user"
	}
        note {
	    label "Note"
	}
    }

db_multirow -extend {note_chk return_url} note_lines notes_lines "
  select
	n.note_id,  
	n.object_id,  
	n.note,
	o.creation_user,
	p.first_names || p.last_name as creation_user,
	to_char(o.creation_date, 'YYYY-MM-DD') as creation_date
  from
	notes n
	INNER JOIN acs_objects o ON n.note_id = o.object_id
	INNER JOIN persons p ON o.creation_user = p.person_id
" {
	set note_chk "<input type=\"checkbox\" name=\"note_id\" value=\"$note_id\" id=\"notes_list,$note_id\">"
        set return_url [im_url_with_query]
}	
