<!-- /www/psets/3-notes-permissions/index.adp -->
<master>

<h1>Problem Set 3 "Notes with Permissions"</h1>

<p>
This Problem Set introduces the concept of an OpenACS "object"
with its powerful automated forms and lists. You will learn:
</p>

<ul>
<li>How to control access to an entire OpenACS package
<li>How to control operations on an object
<li>Permission Details: How permissions work
</ul>
<br>

<h1>Reference Material</h1>
<ul>
<li><a href="/doc/permissions.html">Permissions Intro</a>
<li><a href="/doc/permissions-tediously-explained.html">Detailed Permissions Reference</a>
</ul>
<br>


<h1>Example Code</h1>

<table border=0 cellspacing=4 cellpadding=4 width=600>

<tr>
<td class=rowtitle>Action</td>
<td class=rowtitle>Description</td>
<td class=rowtitle>TCL Source</td>
<td class=rowtitle>ADP Source</td>
<td class=rowtitle>SQL Source</td>
</tr>

<tr valign=top>
<td><ul><li><a href="create-data-model"><nobr>create-data-model</nobr></a></ul></td>
<td>Just executes the notes-create.sql script.</td>
<td>(<a href="../show-source?file_name=2-notes/create-data-model.tcl"><nobr>tcl source</nobr></a>)</td>
<td></td>
<td></td>
</tr>

<tr valign=top>
<td><ul><li><nobr>notes-create.sql</nobr></ul></td>
<td>Data-model for the "2-notes" example. Defined the OpenACS object,
including database table and PlPg/SQL database API.</td>
<td></td>
<td></td>
<td>(<a href="../show-source?file_name=2-notes/notes-create.sql"><nobr>sql source</nobr></a>)</td>
</tr>

<tr valign=top>
<td><ul><li><a href="new">new</a></ul></td>
<td>Create, edit and view notes</td>
<td>(<a href="../show-source?file_name=2-notes/new.tcl"><nobr>tcl source</nobr></a>)</td>
<td>(<a href="../show-source?file_name=2-notes/new.adp"><nobr>adp source</nobr></a>)</td>
<td></td>
</tr>

<tr valign=top>
<td><ul><li><a href="list-notes">list-notes</a></ul></td>
<td>Show a list of notes with the option to delete multiple notes</td>
<td>(<a href="../show-source?file_name=2-notes/new.tcl"><nobr>tcl source</nobr></a>)</td>
<td>(<a href="../show-source?file_name=2-notes/new.adp"><nobr>adp source</nobr></a>)</td>
<td></td>
</tr>

<tr valign=top>
<td><ul><li>notes-del</ul></td>
<td>Delete a list of notes notes, being called from list-notes.</td>
<td>(<a href="../show-source?file_name=2-notes/notes-del.tcl"><nobr>tcl source</nobr></a>)</td>
<td></td>
<td></td>
</tr>


<tr valign=top>
<td colspan=5>
<br>
<h1>Excercises</h1>
<ul>
<li>Exercise 2.1 Extend Notes:<br>
    Add a new Notes type "skype" to store Skype IDs.
    <br>&nbsp;
<li>Exercise 2.2 Advanced Formatting:<br>
    Modify the way Notes are rendered and show the note as 
    a HTTP link if the note is a URL or an Email and as skype:xxxxx if the
    note is a skype ID.
    <br>&nbsp;
<li>Exercise 2.3 Relating Notes to Other Objects: <br>
    Extend the Notes object by a field "related_object_id" in order to
    associate a note with other OpenACS/ ]project-open[ object. 
    Check the "categories" for a reference. Extend the /acs-admin/users/one 
    page with a list of all notes related to that user and allow to create 
    new notes in that page.
    <br>&nbsp;
</ul>
</td>
</tr>



</table>

<br>
<p>
<a href="../index">Return to the Problem Set main page</a>
</p>
