
<html>
<head>
<title>Numbers</title>
<LINK REL=STYLESHEET HREF="tcl_manual.css" TYPE="text/css">
</head>
<body bgcolor=white text=black>

<h2>Numbers</h2>

part of <a href="index.adp">Tcl for Web Nerds</a> 
by 
<a href="http://www-swiss.ai.mit.edu/~hal/hal.html">Hal Abelson</a>,
<a href="http://philip.greenspun.com/">Philip Greenspun</a>,
and
<a href="http://sandon.org/l/">Lydia Sandon</a>


<hr>


Arithmetic is not done directly by the Tcl interpreter.  It is done by
calling the C library using the <CODE>expr</CODE> command on arthmetic
expressions.  The detailed parsing rules for arithmetic expressions
depend on the particular Unix implementation, but they are more or
less like in C.

<p>

Here are some examples:

<blockquote>
<code><pre>
# integer division truncates
% expr 7 / 2
3

# the percent sign is used to compute integer remainder
% expr 7%2 

# floating point propagates
% expr 7.0 / 2
3.5

% expr sin(.5)+cos(.9)
1.10103550687

% # a zero in front of number means to interpret as octal
% expr 017 + 01
16

% # a 0x in front means to interpret as hex
% expr 0xA + 1
11

% # numbers can be treated like strings!
% string length 100.34
6
% string range 100.34 0 2
100
</pre></code>
</blockquote>


More:  See <a href="http://www.scriptics.com/man/tcl7.5/TclCmd/expr.n.html">http://www.scriptics.com/man/tcl7.5/TclCmd/expr.n.html</a>.

<H3>Reference</H3>

Here are the numeric functions included in Tcl.  (Details may vary
depending on your Unix implementation of <code>expr</code>.)

<CODE>
<UL>
<LI>abs(x)
<LI>asin(x)
<LI>acos(x)
<LI>atan(x)

<LI>atan2(y,x)<br> atan2 returns the angle theta of the polar
coordinates returned when (x,y) is converted to (r, theta).

<LI>ceil(x)
<LI>cos(x)
<LI>cosh(x)
<LI>double(x)<br>returns x as a double or floating point.
<LI>exp(x)<br>returns e^x
<LI>floor(x)
<LI>fmod(x,y)<br>returns the floating point remainder of x/y.
<LI>hypot(x,y)<br>returns the square root of the sum of x squared plus
y squared, the length of the line from (0,0) to (x,y).
<LI>int(x)<br>truncates x to an integer.
<LI>log(x)<br>returns the natural log of x.
<LI>log10(x)<br>returns log base 10 of x.
<LI>pow(x,y)<br>returns x to the y power.
<LI>round(x)
<LI>sin(x)
<LI>sinh(x)
<LI>sqrt(x)
<LI>tan(x)
<LI>tanh(x)
</UL>
</code>

<br>
<br>
Continue on to <a href="control-structure.adp">Control structure</a>


<hr>
Return to <a href="index.adp">Table of Contents</a>
<br>
<br>
<address><a href="mailto:lsandon@alum.mit.edu">lsandon@alum.mit.edu</a></address>

<center><a href="/comments/add?page_id=4730">Add a comment</a> | <a href="/links/add?page_id=4730">Add a link</a></center>

</body>
</html>






